Index: /LMDZ4/trunk/libf/phylmd/inifis.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/inifis.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/inifis.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE inifis(ngrid,nlayer,
@@ -45,4 +45,5 @@
 cym#include "dimphy.h"
 
+      INCLUDE 'iniprint.h'
       REAL prad,pg,pr,pcpp,punjours
  
@@ -52,4 +53,7 @@
  
       REAL ptimestep
+      CHARACTER (LEN=20) :: modname='inifis'
+      CHARACTER (LEN=80) :: abort_message
+
  
       IF (nlayer.NE.klev) THEN
@@ -58,5 +62,6 @@
          PRINT*,'nlayer     = ',nlayer
          PRINT*,'klev   = ',klev
-         STOP
+         abort_message = ''
+         CALL abort_gcm (modname,abort_message,1)
       ENDIF
 
@@ -66,8 +71,13 @@
          PRINT*,'ngrid     = ',ngrid
          PRINT*,'klon   = ',klon
-         STOP
+         abort_message = ''
+         CALL abort_gcm (modname,abort_message,1)
       ENDIF
 
       RETURN
-9999  STOP'Cette version demande les fichier rnatur.dat et surf.def'
+9999  continue
+      abort_message = 'Cette version demande les fichier rnatur.dat
+     & et surf.def'
+      CALL abort_gcm (modname,abort_message,1)
+
       END
Index: /LMDZ4/trunk/libf/phylmd/iniphysiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/iniphysiq.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/iniphysiq.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -61,4 +61,6 @@
  
       REAL ptimestep
+      CHARACTER (LEN=20) :: modname='iniphysiq'
+      CHARACTER (LEN=80) :: abort_message
  
       IF (nlayer.NE.klev) THEN
@@ -67,5 +69,6 @@
          PRINT*,'nlayer     = ',nlayer
          PRINT*,'klev   = ',klev
-         STOP
+         abort_message = ''
+         CALL abort_gcm (modname,abort_message,1)
       ENDIF
 
@@ -75,5 +78,6 @@
          PRINT*,'ngrid     = ',ngrid
          PRINT*,'klon   = ',klon_glo
-         STOP
+         abort_message = ''
+         CALL abort_gcm (modname,abort_message,1)
       ENDIF
 c$OMP PARALLEL PRIVATE(ibegin,iend) 
@@ -96,4 +100,8 @@
 
       RETURN
-9999  STOP'Cette version demande les fichier rnatur.dat et surf.def'
+9999  CONTINUE
+      abort_message ='Cette version demande les fichier rnatur.dat
+     & et surf.def'
+      CALL abort_gcm (modname,abort_message,1)
+
       END
Index: /LMDZ4/trunk/libf/phylmd/initphysto.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/initphysto.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/initphysto.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 C
@@ -12,4 +12,6 @@
        USE IOIPSL
        USE iophy
+       USE control_mod
+
       implicit none
 
@@ -52,5 +54,4 @@
 #include "serre.h"
 #include "indicesol.h"
-#include "control.h"
 cym#include "dimphy.h"
 
@@ -108,5 +109,5 @@
 C
 	DO l=1,llm
-            nivsigs(l)=float(l)
+            nivsigs(l)=REAL(l)
          ENDDO
 
Index: /LMDZ4/trunk/libf/phylmd/initrrnpb.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/initrrnpb.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/initrrnpb.F90	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Id $
+! $Id$
 !
 SUBROUTINE  initrrnpb(ftsol,pctsrf,masktr,fshtr,hsoltr,tautr,vdeptr,scavtr)
@@ -39,9 +39,16 @@
   REAL                                  :: s
 
+  CHARACTER (LEN=20) :: modname='initrrnpb'
+  CHARACTER (LEN=80) :: abort_message
+
+
   WRITE(*,*)'PASSAGE initrrnpb ...'
 !
 ! Radon it = 1
 !----------------
-  IF ( nbtr .LE. 0 ) STOP '**PHYTRAC:initrrnpb:** nbtr < 0; verifier RN dans traceur.def' 
+  IF ( nbtr .LE. 0 ) then
+    abort_message = '**PHYTRAC:initrrnpb:** nbtr < 0; verifier RN dans traceur.def' 
+    CALL abort_gcm (modname,abort_message,1)
+  ENDIF
   it = 1
   s = 1.E4             ! Source: atome par m2
@@ -68,5 +75,8 @@
 ! 210Pb it = 2
 !----------------
-  IF ( nbtr .LE. 1 ) STOP '**PHYTRAC**:initrrnpb:** nbtr <= 1; verifier PB dans traceur.def' 
+  IF ( nbtr .LE. 1 ) THEN
+    abort_message='**PHYTRAC**:initrrnpb:** nbtr <= 1; verifier PB dans traceur.def' 
+    CALL abort_gcm (modname,abort_message,1)
+  ENDIF
   it = 2
   s = 0.                ! Pas de source 
Index: /LMDZ4/trunk/libf/phylmd/iostart.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/iostart.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/iostart.F90	(revision 1403)
@@ -5,5 +5,5 @@
     INTEGER,SAVE :: nid_restart
     
-    INTEGER,SAVE :: idim1,idim2,idim3
+    INTEGER,SAVE :: idim1,idim2,idim3,idim4
     INTEGER,PARAMETER :: length=100
     
@@ -317,4 +317,5 @@
       ierr = NF90_DEF_DIM (nid_restart, "points_physiques", klon_glo, idim2)
       ierr = NF90_DEF_DIM (nid_restart, "horizon_vertical", klon_glo*klev, idim3)
+      ierr = NF90_DEF_DIM (nid_restart, "horizon_klevp1", klon_glo*klevp1, idim4)
 
       ierr = NF90_ENDDEF(nid_restart)
@@ -386,9 +387,11 @@
     
     IF (is_mpi_root .AND. is_omp_root) THEN
-      
+
       IF (field_size==1) THEN
         idim=idim2
       ELSE IF (field_size==klev) THEN
         idim=idim3
+      ELSE IF (field_size==klevp1) THEN
+        idim=idim4
       ELSE
         PRINT *, "erreur phyredem : probleme de dimension"
@@ -467,5 +470,5 @@
          
     IF (is_mpi_root .AND. is_omp_root) THEN
-    
+
       IF (var_size/=length) THEN
         PRINT *, "erreur phyredem : probleme de dimension"
Index: /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_omp_data.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_omp_data.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_omp_data.F90	(revision 1403)
@@ -1,4 +1,4 @@
 !
-!$Header$
+!$Id$
 !
 MODULE mod_phys_lmdz_omp_data
@@ -27,4 +27,8 @@
     INTEGER :: i
 
+    CHARACTER (LEN=20) :: modname='Init_phys_lmdz_omp_data'
+    CHARACTER (LEN=80) :: abort_message
+
+
 #ifdef CPP_OMP    
     INTEGER :: OMP_GET_NUM_THREADS
@@ -51,6 +55,6 @@
      is_omp_root=.TRUE.
    ELSE
-     PRINT *,'ANORMAL : OMP_MASTER /= 0'
-     STOP
+     abort_message = 'ANORMAL : OMP_MASTER /= 0'
+     CALL abort_gcm (modname,abort_message,1)
    ENDIF
 !$OMP END MASTER
Index: /LMDZ4/trunk/libf/phylmd/moy_undefSTD.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/moy_undefSTD.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/moy_undefSTD.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE moy_undefSTD(itap,freq_outNMC,freq_moyNMC)
Index: /LMDZ4/trunk/libf/phylmd/o3_chem_m.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/o3_chem_m.F90	(revision 1403)
+++ /LMDZ4/trunk/libf/phylmd/o3_chem_m.F90	(revision 1403)
@@ -0,0 +1,172 @@
+! $Id$
+module o3_chem_m
+
+  IMPLICIT none
+
+  private o3_prod
+
+contains
+
+  subroutine o3_chem(julien, gmtime, t_seri, zmasse, pdtphys, rlat, rlon, q)
+
+    ! This procedure evolves the ozone mass fraction through a time
+    ! step taking only chemistry into account.
+
+    ! All the 2-dimensional arrays are on the partial "physics" grid.
+    ! Their shape is "(/klon, llm/)".
+    ! Index "(i, :)" is for longitude "rlon(i)", latitude "rlat(i)".
+
+    use assert_m, only: assert
+    use dimphy, only: klon
+    use regr_pr_comb_coefoz_m, only: c_Mob, a4_mass, a2, r_het_interm
+
+    integer, intent(in):: julien ! jour julien, 1 <= julien <= 360
+    real, intent(in):: gmtime ! heure de la journée en fraction de jour
+    real, intent(in):: t_seri(:, :) ! (klon, llm) temperature, in K
+
+    real, intent(in):: zmasse(:, :) ! (klon, llm)
+    ! (column-density of mass of air in a cell, in kg m-2)
+    ! "zmasse(:, k)" is for layer "k".)
+
+    real, intent(in):: pdtphys ! time step for physics, in s
+
+    REAL, intent(in):: rlat(:), rlon(:)
+    ! (longitude and latitude of each horizontal position, in degrees)
+
+    real, intent(inout):: q(:, :) ! (klon, llm) mass fraction of ozone
+    ! "q(:, k)" is at middle of layer "k".)
+
+    ! Variables local to the procedure:
+    include "dimensions.h"
+    include "comconst.h"
+    ! (for "pi")
+    integer k
+
+    real c(klon, llm)
+    ! (constant term during a time step in the net mass production
+    ! rate of ozone by chemistry, per unit mass of air, in s-1)
+    ! "c(:, k)" is at middle of layer "k".)
+
+    real b(klon, llm)
+    ! (coefficient of "q" in the net mass production
+    ! rate of ozone by chemistry, per unit mass of air, in s-1)
+    ! "b(:, k)" is at middle of layer "k".)
+
+    real dq_o3_chem(klon, llm)
+    ! (variation of ozone mass fraction due to chemistry during a time step)
+    ! "dq_o3_chem(:, k)" is at middle of layer "k".)
+
+    real earth_long
+    ! (longitude vraie de la Terre dans son orbite solaire, par
+    ! rapport au point vernal (21 mars), en degrés)
+
+    real pmu0(klon) ! mean of cosine of solar zenith angle during "pdtphys"
+    real trash1
+    real trash2(klon)
+
+    !-------------------------------------------------------------
+
+    call assert(klon == (/size(q, 1), size(t_seri, 1), size(zmasse, 1), &
+         size(rlat), size(rlon)/), "o3_chem klon")
+    call assert(llm == (/size(q, 2), size(t_seri, 2), size(zmasse, 2)/), &
+         "o3_chem llm")
+
+    c = c_Mob + a4_mass * t_seri
+
+    ! Compute coefficient "b":
+
+    ! Heterogeneous chemistry is only at low temperature:
+    where (t_seri < 195.)
+       b = r_het_interm
+    elsewhere
+       b = 0.
+    end where
+
+    ! Heterogeneous chemistry is only during daytime:
+    call orbite(real(julien), earth_long, trash1)
+    call zenang(earth_long, gmtime, pdtphys, rlat, rlon, pmu0, trash2)
+    forall (k = 1: llm)
+       where (pmu0 <= cos(87. / 180. * pi)) b(:, k) = 0.
+    end forall
+
+    b = b + a2
+
+    ! Midpoint method:
+
+    ! Trial step to the midpoint:
+    dq_o3_chem = o3_prod(q, zmasse, c, b) * pdtphys  / 2
+    ! "Real" step across the whole interval:
+    dq_o3_chem = o3_prod(q + dq_o3_chem, zmasse, c, b) * pdtphys
+    q = q + dq_o3_chem
+
+    ! Confine the mass fraction:
+    q = min(max(q, 0.), .01)
+
+  end subroutine o3_chem
+
+  !*************************************************
+
+  function o3_prod(q, zmasse, c, b)
+
+    ! This function computes the production rate of ozone by chemistry.
+
+    ! All the 2-dimensional arrays are on the partial "physics" grid.
+    ! Their shape is "(/klon, llm/)".
+    ! Index "(i, :)" is for longitude "rlon(i)", latitude "rlat(i)".
+
+    use regr_pr_comb_coefoz_m, only: a6_mass
+    use assert_m, only: assert
+    use dimphy, only: klon
+
+    real, intent(in):: q(:, :) ! mass fraction of ozone
+    ! "q(:, k)" is at middle of layer "k".)
+
+    real, intent(in):: zmasse(:, :)
+    ! (column-density of mass of air in a layer, in kg m-2)
+    ! ("zmasse(:, k)" is for layer "k".)
+
+    real, intent(in):: c(:, :)
+    ! (constant term during a time step in the net mass production
+    ! rate of ozone by chemistry, per unit mass of air, in s-1)
+    ! "c(:, k)" is at middle of layer "k".)
+
+    real, intent(in):: b(:, :)
+    ! (coefficient of "q" in the net mass production rate of ozone by
+    ! chemistry, per unit mass of air, in s-1)
+    ! ("b(:, k)" is at middle of layer "k".)
+
+    include "dimensions.h"
+
+    real o3_prod(klon, llm)
+    ! (net mass production rate of ozone by chemistry, per unit mass
+    ! of air, in s-1)
+    ! ("o3_prod(:, k)" is at middle of layer "k".)
+
+    ! Variables local to the procedure:
+
+    real sigma_mass(klon, llm)
+    ! (mass column-density of ozone above point, in kg m-2)
+    ! ("sigma_mass(:, k)" is at middle of layer "k".)
+
+    integer k
+
+    !-------------------------------------------------------------------
+
+    call assert(klon == (/size(q, 1), size(zmasse, 1), size(c, 1), &
+         size(b, 1)/), "o3_prod 1")
+    call assert(llm == (/size(q, 2), size(zmasse, 2), size(c, 2), &
+         size(b, 2)/), "o3_prod 2")
+
+    ! Compute the column-density above the base of layer
+    ! "k", and, as a first approximation, take it as column-density
+    ! above the middle of layer "k":
+    sigma_mass(:, llm) = zmasse(:, llm) * q(:, llm) ! top layer
+    do k =  llm - 1, 1, -1
+       sigma_mass(:, k) = sigma_mass(:, k+1) + zmasse(:, k) * q(:, k)
+    end do
+
+    o3_prod = c + b * q + a6_mass * sigma_mass
+
+  end function o3_prod
+
+end module o3_chem_m
Index: /LMDZ4/trunk/libf/phylmd/o3cm.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/o3cm.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/o3cm.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE o3cm (amb, bmb, sortie, ntab)
@@ -19,4 +19,6 @@
 c======================================================================
       external mbtozm
+      CHARACTER (LEN=20) :: modname=''
+      CHARACTER (LEN=80) :: abort_message
 c======================================================================
 c la fonction en ligne w(x) donne le profil de l'ozone en fonction
@@ -27,6 +29,9 @@
       w(x) = wp/h * EXP((x-xp)/h)/ (con+EXP((x-xp)/h))**2
 c======================================================================
-      IF (ntab .GT. 499) STOP 'BIG ntab'
-      xincr = (bmb-amb) / FLOAT(ntab)
+      IF (ntab .GT. 499) THEN
+        abort_message = 'BIG ntab'
+        CALL abort_gcm (modname,abort_message,1)
+      ENDIF
+      xincr = (bmb-amb) / REAL(ntab)
       xtab(1) = amb
       DO n = 2, ntab
Index: /LMDZ4/trunk/libf/phylmd/orografi.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/orografi.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/orografi.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE drag_noro (nlon,nlev,dtime,paprs,pplay,
@@ -1497,4 +1497,6 @@
      *       ZDVDT(KLON)
       REAL ZHCRIT(KLON,KLEV)
+      CHARACTER (LEN=20) :: modname='orografi'
+      CHARACTER (LEN=80) :: abort_message
 C-----------------------------------------------------------------------
 C
@@ -1504,5 +1506,8 @@
       LIFTHIGH=.FALSE.
 
-      IF(NLON.NE.KLON.OR.NLEV.NE.KLEV)STOP
+      IF(NLON.NE.KLON.OR.NLEV.NE.KLEV)THEN
+        abort_message = 'pb dimension'
+        CALL abort_gcm (modname,abort_message,1)
+      ENDIF
       ZCONS1=1./RD
 cym      KLEVM1=KLEV-1
Index: /LMDZ4/trunk/libf/phylmd/orografi_strato.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/orografi_strato.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/orografi_strato.F	(revision 1403)
@@ -89,4 +89,6 @@
       REAL pt(klon,klev), pu(klon,klev), pv(klon,klev)
       REAL papmf(klon,klev),papmh(klon,klev+1)
+      CHARACTER (LEN=20) :: modname='orografi_strato'
+      CHARACTER (LEN=80) :: abort_message
 c
 c INITIALIZE OUTPUT VARIABLES 
@@ -1680,4 +1682,7 @@
       logical lifthigh
       real zcons1,ztmst
+      CHARACTER (LEN=20) :: modname='orolift_strato'
+      CHARACTER (LEN=80) :: abort_message
+
 
 C-----------------------------------------------------------------------
@@ -1688,5 +1693,8 @@
       lifthigh=.false.
 
-      if(nlon.ne.klon.or.nlev.ne.klev)stop
+      if(nlon.ne.klon.or.nlev.ne.klev) then
+        abort_message = 'pb dimension'
+        CALL abort_gcm (modname,abort_message,1)
+      ENDIF
       zcons1=1./rd
       ztmst=ptsphy
Index: /LMDZ4/trunk/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 1403)
@@ -22,4 +22,6 @@
   USE climb_wind_mod,      ONLY : climb_wind_down, climb_wind_up
   USE coef_diff_turb_mod,  ONLY : coef_diff_turb
+  USE control_mod
+
 
   IMPLICIT NONE
@@ -257,5 +259,4 @@
     INCLUDE "YOETHF.h"
     INCLUDE "temps.h"
-    INCLUDE "control.h"
 ! Input variables
 !****************************************************************************************
@@ -483,5 +484,5 @@
       
        ! Initialize ok_flux_surf (for 1D model)
-       ok_flux_surf=.FALSE.
+       if (klon>1) ok_flux_surf=.FALSE.
        
        ! Initilize debug IO
@@ -657,5 +658,5 @@
           tabindx(:)=0.
           DO i=1,knon
-             tabindx(i)=FLOAT(i)
+             tabindx(i)=REAL(i)
           END DO
           debugtab(:,:) = 0.
Index: /LMDZ4/trunk/libf/phylmd/phyetat0.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -228,4 +228,5 @@
      $          'coherente ', i, zmasq(i), pctsrf(i, is_ter)
      $          ,pctsrf(i, is_lic)
+            WRITE(*,*) 'Je force la coherence zmasq=fractint'
             zmasq(i) = fractint(i)
         ENDIF 
@@ -238,4 +239,5 @@
      $          'coherente ', i, zmasq(i) , pctsrf(i, is_oce)
      $          ,pctsrf(i, is_sic)
+            WRITE(*,*) 'Je force la coherence zmasq=fractint'
             zmasq(i) = fractint(i)
         ENDIF 
@@ -987,4 +989,18 @@
       PRINT*,'(ecart-type) wake_cstar:', xmin, xmax
 c
+c wake_pe
+c
+      CALL get_field("WAKE_PE",wake_pe,found)
+      IF (.NOT. found) THEN
+         PRINT*, "phyetat0: Le champ <WAKE_PE> est absent"
+         PRINT*, "Depart legerement fausse. Mais je continue"
+         wake_pe=0.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(wake_pe)
+      xmax = MAXval(wake_pe)
+      PRINT*,'(ecart-type) wake_pe:', xmin, xmax
+c
 c wake_fip
 c
@@ -1000,4 +1016,46 @@
       xmax = MAXval(wake_fip)
       PRINT*,'(ecart-type) wake_fip:', xmin, xmax
+c
+c  thermiques
+c
+
+      CALL get_field("FM_THERM",fm_therm,found)
+      IF (.NOT. found) THEN
+         PRINT*, "phyetat0: Le champ <fm_therm> est absent"
+         PRINT*, "Depart legerement fausse. Mais je continue"
+         fm_therm=0.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(fm_therm)
+      xmax = MAXval(fm_therm)
+      PRINT*,'(ecart-type) fm_therm:', xmin, xmax
+
+      CALL get_field("ENTR_THERM",entr_therm,found)
+      IF (.NOT. found) THEN
+         PRINT*, "phyetat0: Le champ <entr_therm> est absent"
+         PRINT*, "Depart legerement fausse. Mais je continue"
+         entr_therm=0.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(entr_therm)
+      xmax = MAXval(entr_therm)
+      PRINT*,'(ecart-type) entr_therm:', xmin, xmax
+
+      CALL get_field("DETR_THERM",detr_therm,found)
+      IF (.NOT. found) THEN
+         PRINT*, "phyetat0: Le champ <detr_therm> est absent"
+         PRINT*, "Depart legerement fausse. Mais je continue"
+         detr_therm=0.
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(detr_therm)
+      xmax = MAXval(detr_therm)
+      PRINT*,'(ecart-type) detr_therm:', xmin, xmax
+
+
+
 c
 c Read and send field trs to traclmdz
Index: /LMDZ4/trunk/libf/phylmd/phyredem.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -14,4 +14,6 @@
       USE traclmdz_mod, ONLY : traclmdz_to_restart
       USE infotrac
+      USE control_mod
+
 
       IMPLICIT none
@@ -24,5 +26,4 @@
 #include "dimsoil.h"
 #include "clesphys.h"
-#include "control.h"
 #include "temps.h"
 #include "thermcell.h"
@@ -247,23 +248,23 @@
       ENDDO
 c
-      CALL put_field("ZMEA","",zmea)
-c
-      CALL put_field("ZSTD","",zstd)
-      
-      CALL put_field("ZSIG","",zsig)
-      
-      CALL put_field("ZGAM","",zgam)
-      
-      CALL put_field("ZTHE","",zthe)
-      
-      CALL put_field("ZPIC","",zpic)
-      
-      CALL put_field("ZVAL","",zval)
+      CALL put_field("ZMEA","ZMEA",zmea)
+c
+      CALL put_field("ZSTD","ZSTD",zstd)
+      
+      CALL put_field("ZSIG","ZSIG",zsig)
+      
+      CALL put_field("ZGAM","ZGAM",zgam)
+      
+      CALL put_field("ZTHE","ZTHE",zthe)
+      
+      CALL put_field("ZPIC","ZPIC",zpic)
+      
+      CALL put_field("ZVAL","ZVAL",zval)
       
       CALL put_field("RUGSREL","RUGSREL",rugoro)
       
-      CALL put_field("TANCIEN","",t_ancien)
-      
-      CALL put_field("QANCIEN","",q_ancien)
+      CALL put_field("TANCIEN","TANCIEN",t_ancien)
+      
+      CALL put_field("QANCIEN","QANCIEN",q_ancien)
       
       CALL put_field("RUGMER","Longueur de rugosite sur mer",
@@ -298,25 +299,34 @@
 !!!!!!!!!!!!!!!!!!!! FIN TKE PBL !!!!!!!!!!!!!!!!!!!!!!!!!
 cIM ajout zmax0, f0, ema_work1, ema_work2
-cIM wake_deltat, wake_deltaq, wake_s, wake_cstar, wake_fip
-      
-      CALL put_field("ZMAX0","",zmax0)
-      
-      CALL put_field("F0","",f0)
-      
-      CALL put_field("EMA_WORK1","",ema_work1)
-      
-      CALL put_field("EMA_WORK2","",ema_work2)
+cIM wake_deltat, wake_deltaq, wake_s, wake_cstar, wake_pe, wake_fip
+      
+      CALL put_field("ZMAX0","ZMAX0",zmax0)
+      
+      CALL put_field("F0","F0",f0)
+      
+      CALL put_field("EMA_WORK1","EMA_WORK1",ema_work1)
+      
+      CALL put_field("EMA_WORK2","EMA_WORK2",ema_work2)
       
 c wake_deltat
-      CALL put_field("WAKE_DELTAT","",wake_deltat)
-
-      CALL put_field("WAKE_DELTAQ","",wake_deltaq)
-      
-      CALL put_field("WAKE_S","",wake_s)
-      
-      CALL put_field("WAKE_CSTAR","",wake_cstar)
-      
-      CALL put_field("WAKE_FIP","",wake_fip)
-
+      CALL put_field("WAKE_DELTAT","WAKE_DELTAT",wake_deltat)
+
+      CALL put_field("WAKE_DELTAQ","WAKE_DELTAQ",wake_deltaq)
+      
+      CALL put_field("WAKE_S","WAKE_S",wake_s)
+      
+      CALL put_field("WAKE_CSTAR","WAKE_CSTAR",wake_cstar)
+      
+      CALL put_field("WAKE_PE","WAKE_PE",wake_pe)
+
+      CALL put_field("WAKE_FIP","WAKE_FIP",wake_fip)
+
+c thermiques
+
+      CALL put_field("FM_THERM","FM_THERM",fm_therm)
+
+      CALL put_field("ENTR_THERM","ENTR_THERM",entr_therm)
+
+      CALL put_field("DETR_THERM","DETR_THERM",detr_therm)
 
 ! trs from traclmdz_mod
